/*
   ####################################################################################
   #                                                                                  #
   #                             LibCodeBananas V3.0.0                                #
   #                     Ttybanana - Serial communication tools                       #
   #                                                                                  #
   #    Copyright (C) 2006-2010 Philipp Fabian Benedikt Maier (aka. Dexter)           #
   #                                                                                  #
   #    This program is free software; you can redistribute it and/or modify          #
   #    it under the terms of the GNU General Public License as published by          #
   #    the Free Software Foundation; either version 2 of the License, or             #
   #    (at your option) any later version.                                           #
   #                                                                                  #
   #    This program is distributed in the hope that it will be useful,               #
   #    but WITHOUT ANY WARRANTY; without even the implied warranty of                #
   #    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 #
   #    GNU General Public License for more details.                                  #
   #                                                                                  #
   #    You should have received a copy of the GNU General Public License             #
   #    along with this program; if not, write to the Free Software                   #
   #    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA    #
   #                                                                                  #
   #################################################################################### */

/* ####################################################################################
   #                                                                                  #
   #  This library (as far as you could call this a "library") is dedicated to all    #
   #  novice C programmers who look for a quick and easy method to access the serial  #
   #  port. I have derived this from a various type of programming exemples I         #
   #  do not pretend that i really know what i am doing so use it on your own risk    #
   #                                                                                  #
   #################################################################################### */

/* ## HEADER ########################################################################## */
#ifndef ttybanana_h
#define ttybanana_h

/* Possible parity modes for ttyInit() and ttyInitProf() */
#define NONE 0
#define ODD 1
#define EVEN 2

/* Control line identifiers for ttySetCtrl() and ttyGetCtrl() */
#define LE	1
#define DTR	2
#define RTS	3
#define ST	4
#define SR	5
#define CTS	6
#define RNG	7
#define DSR	8

#ifdef __cplusplus
#define EXTERN extern "C"
#else
#define EXTERN
#endif/*__cplusplus*/

EXTERN void ttyInit(char *ttyDevice, int ttyBaudrate);
EXTERN void ttyInitProf(char *ttyDevice, int ttyBaudrate, int ttyFrameSize, int ttyParity);
EXTERN void ttyWrite(char *ttyDevice, char *ttyMessage);
EXTERN void ttyWriteLen(char *ttyDevice,char *ttyMessage, int messagesize);
EXTERN void ttyWriteLenSlow (char *ttyDevice, char *ttyMessage, int messagesize, int delay);	/* Write to a tty-device and specify a length and a user defined delay*/
EXTERN void ttyRead(char *ttyDevice, int numberOfBytes, char *ttyMessage);
EXTERN int ttyReadDynamic (char *ttyDevice, char *ttyMessage, int timeout);			/* Read from a tty-device till buffer is empty (blocking) */
EXTERN int ttyReadNonblocking (char *ttyDevice, char *ttyMessage, int timeout);			/* Read from a tty-device till buffer is empty (nonblocking) */
EXTERN char ttyGetchar (char *ttyDevice);
EXTERN void ttyPutchar (char *ttyDevice, char ttyChar);
EXTERN void ttyClearBuffer(char *ttyDevice);							/* Clear device buffer */
EXTERN void ttySetCtrl(char *ttyDevice, int controlLine, int status);				/* Set control line status */
EXTERN int ttyGetCtrl(char *ttyDevice, int controlLine);					/* Get control line status */


#endif/*ttybanana_h*/
/* #################################################################################### */

